# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from . import utilities, tables

class Tag(pulumi.CustomResource):
    """
    The `vsphere_tag` resource can be used to create and manage tags, which allow
    you to attach metadata to objects in the vSphere inventory to make these
    objects more sortable and searchable.
    
    For more information about tags, click [here][ext-tags-general].
    
    [ext-tags-general]: https://docs.vmware.com/en/VMware-vSphere/6.5/com.vmware.vsphere.vcenterhost.doc/GUID-E8E854DD-AA97-4E0C-8419-CE84F93C4058.html
    
    ~> **NOTE:** Tagging support is unsupported on direct ESXi connections and
    requires vCenter 6.0 or higher.
    """
    def __init__(__self__, __name__, __opts__=None, category_id=None, description=None, name=None):
        """Create a Tag resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not category_id:
            raise TypeError('Missing required property category_id')
        __props__['category_id'] = category_id

        __props__['description'] = description

        __props__['name'] = name

        super(Tag, __self__).__init__(
            'vsphere:index/tag:Tag',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

